#ifndef __FREEBSD_IOCTL_SAS_H__
#define __FREEBSD_IOCTL_SAS_H__


#include <iostream>
#include <pthread.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>          /* File control definitions */
#include <errno.h>          /* Error number definitions */
#include <unistd.h>         /* fork() */
#include <netinet/in.h>
#include <netdb.h>
#include <stdarg.h>
#ifdef __linux__
	#include <scsi/sg.h>
	#include <sys/ipc.h>
	#include <sys/shm.h>
#endif
#include <sys/ioctl.h>
#include <unistd.h>

#include "commdef.h"
#include "if.h"

class FreeBSDIoctlSASInterface : public ArcInterface
{
public:
	FreeBSDIoctlSASInterface();
	~FreeBSDIoctlSASInterface();
	bool init(const int nScsiPort);
	int send(sIF_CMD_BLOCK *ifData);
	int recv(sIF_CMD_BLOCK *ifData);
	int syncSend(sIF_CMD_BLOCK *ifData);
	void requirelock();
	void releaselock();
	int	getMTU();
	void *getDeviceHandle();
private:
	BOOL ClearReadBuffer();
	BOOL ClearWriteBuffer();
	BOOL ClearReadWriteBuffer();
	HANDLE  m_hScsi;
	int fd;
	pthread_mutex_t mut;
};

#endif
